BeanBuilder (Jackson JSON Processor)
Date: 2013-07-14

org.codehaus.jackson.mrbean

## Class BeanBuilder

- java.lang.Object
- - org.codehaus.jackson.mrbean.BeanBuilder

-     public class BeanBuilder
      extends Object

  Heavy lifter of mr Bean package: class that keeps track of logical POJO properties, and figures out how to create an implementation class.
  Since:
    1.6

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected Map<String,org.codehaus.jackson.mrbean.BeanBuilder.Property>` | `_beanProperties`
    `protected Class<?>` | `_implementedType` Abstract class or interface that the bean is created to extend or implement.
    `protected TypeFactory` | `_typeFactory`
    `protected LinkedHashMap<String,Method>` | `_unsupportedMethods`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `BeanBuilder(DeserializationConfig config, Class<?> implType)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `byte[]` | `build(String className)` Method that generates byte code for class that implements abstract types requested so far.
    `BeanBuilder` | `implement(boolean failOnUnrecognized)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### _beanProperties

          protected Map<String,org.codehaus.jackson.mrbean.BeanBuilder.Property> _beanProperties

    - #### _unsupportedMethods

          protected LinkedHashMap<String,Method> _unsupportedMethods

    - #### _implementedType

          protected final Class<?> _implementedType

      Abstract class or interface that the bean is created to extend or implement.

    - #### _typeFactory

          protected final TypeFactory _typeFactory

  - ### Constructor Detail

    - #### BeanBuilder

          public BeanBuilder(DeserializationConfig config,
                     Class<?> implType)

  - ### Method Detail

    - #### implement

          public BeanBuilder implement(boolean failOnUnrecognized)

      Parameters:
        `failOnUnrecognized` - If true, and an unrecognized (non-getter, non-setter) method is encountered, will throw `IllegalArgumentException`; if false, will implement bogus method that will throw `UnsupportedOperationException` if called.

    - #### build

          public byte[] build(String className)

      Method that generates byte code for class that implements abstract types requested so far.
      Parameters:
        `className` - Fully-qualified name of the class to generate
      Returns:
        Byte code Class instance built by this builder